;################################################# MIRCCRYPT DIALOG STARTS HERE #############################################
dialog mircCrypt {
  size 37 178 530 485
  title "mircCrypt v2.1"
  tab "Settings", 31, 5 5 520 475
  tab "Readme", 32
  list 1, 24 219 150 150, tab 31
  list 2, 183 219 150 150, tab 31
  list 3, 342 219 150 150, tab 31
  button "Add", 4, 24 370 27 20, tab 31
  button "Del", 5, 53 370 24 20, tab 31
  button "Edit", 6, 79 370 26 20, tab 31
  button "Clear List", 7, 123 370 51 20, tab 31
  button "Add", 8, 184 370 27 20, tab 31
  button "Del", 9, 213 370 24 20, tab 31
  button "Edit", 10, 239 370 26 20, tab 31
  button "Clear List", 11, 282 370 51 20, tab 31
  button "Add", 12, 342 370 27 20, tab 31
  button "Del", 13, 371 370 24 20, tab 31
  button "Edit", 14, 397 370 26 20, tab 31
  button "Clear List", 15, 441 370 51 20, tab 31
  text "Enable active Encryption on:", 16, 27 206 160 13, left, tab 31
  text "Key for Channel:", 17, 187 206 100 13, left, tab 31
  text "Key for Qry with:", 18, 347 206 100 13, left, tab 31
  check "mircCrypt activated", 19, 26 409 146 17, tab 31
  icon 20, 10 40 507 116, mirccrypt.jpg, noborder, tab 31
  button "OK", 24, 448 403 23 20, ok, tab 31
  button "Cancel", 25, 473 403 41 20, cancel, tab 31
  text "mircCrypt Version 2.1 (C) by And[y]", 26, 178 151 185 13, left, tab 31
  check "Check for Updates @ startup", 27, 26 429 165 17, tab 31
  check "Localecho encrypted messages", 28, 200 409 165 17, tab 31
  check "Encrypt saved passwords:", 29, 200 429 165 17, tab 31
  edit "", 21, 200 449 165 17, pass, tab 31
  list 33, 10 40 507 430, vsbar hsbar, tab 32
}

;################################################ POPUP MENUS START HERE ####################################################
menu menubar {
  mircCrypt : { $mircCrypt.config }
}

menu query,nicklist {
  mircCrypt
  .$iif($istok(%mircCrypt.Nicks,$1,32) == $true,$+(Remove,$chr(32),$1,$chr(39),s,$chr(32),Key),$+(Add,$chr(32),$1,$chr(39),s,$chr(32),Key)): {
    if ($istok(%mircCrypt.Nicks,$1,32) == $true) {
      ;if there is only one item remaining:
      if ($numtok(%mircCrypt.Nicks,32) == 1) {
        ;remove the tokens for the Nicks and the NickKeys:
        unset %mircCrypt.Nicks
        unset %mircCrypt.NickKeys
      }
      ;if there is more than one item remaining:
      else {
        %mircCrypt.temp = $findtok(%mircCrypt.Nicks,$1,32)
        ;remove the selected Nick from the nick token:
        %mircCrypt.Nicks = $remtok(%mircCrypt.Nicks,$1,32)
        ;remove the Key for the selected item from the NickKeys token:
        %mircCrypt.NickKeys = $deltok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
      }
    }
    else {
      %mircCrypt.Nicks = $addtok(%mircCrypt.Nicks,$1,32)
      set %mircCrypt.temp $?*="Enter Key"
      ;if the new key is allready an item of the token, warn the user to chose another key:
      if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) {
        :again 
        set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
        if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) { goto again }
      }
      ;add the new Key to the token of the NickKeys:
      %mircCrypt.NickKeys = $addtok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
    }
    $mircCrypt.SaveSettings
  }

  .$iif($istok(%mircCrypt.ActiveCrypting,$1,32) == $true,Disable ActiveCrypting for $1,Enable ActiveCrypting for $1): {
    if ($istok(%mircCrypt.ActiveCrypting,$1,32) == $true) {
      if ($numtok(%mircCrypt.ActiveCrypting,32) == 1) {
        unset %mircCrypt.ActiveCrypting
      }
      ;there is more than one item left:
      else {
        %mircCrypt.ActiveCrypting = $remtok(%mircCrypt.ActiveCrypting,$1,32) 
      }
    }
    else {
      %mircCrypt.ActiveCrypting = $addtok(%mircCrypt.ActiveCrypting,$1,32)
    }
    $mircCrypt.SaveSettings
  }
}

menu channel {
  mircCrypt
  .$iif($istok(%mircCrypt.Chans,#,32) == $true,$+(Remove,$chr(32),#,$chr(39),s,$chr(32),Key),$+(Add,$chr(32),#,$chr(39),s,$chr(32),Key)): {
    if ($istok(%mircCrypt.Chans,#,32) == $true) {
      ;if there is only one item remaining:
      if ($numtok(%mircCrypt.Chans,32) == 1) {
        ;remove the tokens for the Chans and the ChanKeys:
        unset %mircCrypt.Chans
        unset %mircCrypt.ChanKeys
      }
      ;if there is more than one item remaining:
      else {
        %mircCrypt.temp = $findtok(%mircCrypt.Chans,#,32)
        ;remove the selected Chan from the Chan token:
        %mircCrypt.Chans = $remtok(%mircCrypt.Chans,#,32)
        ;remove the Key for the selected item from the ChanKeys token:
        %mircCrypt.ChanKeys = $deltok(%mircCrypt.ChanKeys,%mircCrypt.temp,32)
      }
    }
    else {
      %mircCrypt.Chans = $addtok(%mircCrypt.Chans,#,32)
      set %mircCrypt.temp $?*="Enter Key"
      ;if the new key is allready an item of the token, warn the user to chose another key:
      if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) {
        :again 
        set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
        if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) { goto again }
      }
      ;add the new Key to the token of the NickKeys:
      %mircCrypt.ChanKeys = $addtok(%mircCrypt.ChanKeys,%mircCrypt.temp,32)
    }
    $mircCrypt.SaveSettings
  }

  .$iif($istok(%mircCrypt.ActiveCrypting,#,32) == $true,Disable ActiveCrypting for #,Enable ActiveCrypting for #): {
    if ($istok(%mircCrypt.ActiveCrypting,#,32) == $true) {
      if ($numtok(%mircCrypt.ActiveCrypting,32) == 1) {
        unset %mircCrypt.ActiveCrypting
      }
      ;there is more than one item left:
      else {
        %mircCrypt.ActiveCrypting = $remtok(%mircCrypt.ActiveCrypting,#,32) 
      }
    }
    else {
      %mircCrypt.ActiveCrypting = $addtok(%mircCrypt.ActiveCrypting,#,32)
    }
    $mircCrypt.SaveSettings
  }
}

;##################################################### ALIASES START HERE ###################################################
;Alias for opening the mircCrypt-dialog
alias mircCrypt.config {
  ;if it is allready loaded, but in the background
  if ($dialog(mircCrypt)) {
    ;we simply let it display:
    dialog -v mircCrypt
  } 
  ;instead of creating it:
  else {
    dialog -mdr mircCrypt mircCrypt
  }
} 

;This alias manages the loading of the variables. It opens the ini and parses some of the values:
alias -l mircCrypt.LoadSettings {
  ;read the settings for %mircCrypt.Active, %mircCrypt.Chans, %mircCrypt.ChanKey, %mircCrypt.Nicks and
  ;%mircCrypt.NickKeys direclty from the ini-file:
  set %mircCrypt.ActiveCrypting $readini(mirccrypt.ini, active, 1)
  set %mircCrypt.Chans $readini(mirccrypt.ini, chans, 1)
  set %mircCrypt.ChanKeys $readini(mirccrypt.ini, chans, 2)
  set %mircCrypt.Nicks $readini(mirccrypt.ini, qrys, 1)
  set %mircCrypt.NickKeys $readini(mirccrypt.ini, qrys, 2)

  ;Load the value for Active:
  set %mircCrypt.Active $readini(mirccrypt.ini, general, active)

  ;Load the value for AutoUpdate:
  set %mircCrypt.AutoUpdate $readini(mirccrypt.ini, general, AutoUpdate)

  ;Load the value for Localecho:
  set %mircCrypt.Localecho $readini(mirccrypt.ini, general, Localecho)

  ;Load the value for EncryptPasses. 
  set %mircCrypt.EncryptPasses $readini(mirccrypt.ini, general, EncryptPasses)

  ;Now load the key and check if it is valid or unvalid. If it is unvalid:
  set %mircCrypt.Password $readini(mirccrypt.ini, general, Password)
  if ((%mircCrypt.Password == $null) || (%mircCrypt.Password == 0)) {
    ;set the variables to disable the feature:
    set %mircCrypt.EncryptPasses 0
    set %mircCrypt.Password 0
  }
}

;This alias manages the saving of the variables. It opens the ini writes the values after parsing some:
alias -l mircCrypt.SaveSettings {
  ;Write the settings for %mircCrypt.Active, %mircCrypt.AutoUpdate, %mircCrypt.Localecho and %mircCrypt.EncryptPasses 
  ;direclty to the ini-file:
  writeini mirccrypt.ini general active %mircCrypt.Active
  writeini mirccrypt.ini general AutoUpdate %mircCrypt.AutoUpdate
  writeini mirccrypt.ini general Localecho %mircCrypt.Localecho
  writeini mirccrypt.ini general EncryptPasses %mircCrypt.EncryptPasses
  writeini mirccrypt.ini general Password %mircCrypt.Password

  ;if the list of the nicks & chans, where the chat should be encrypted automatically (without the need to call an alias to
  ;write encrypted) has at least one item, we write the list directly to the ini-file, else we remove the key from the ini:
  if ($len(%mircCrypt.ActiveCrypting) != 0) { writeini mirccrypt.ini active 1 %mircCrypt.ActiveCrypting }
  else { remini mirccrypt.ini active 1 }

  ;Same as for the ActiveCrypting-list:
  if ($len(%mircCrypt.Chans) != 0) { writeini mirccrypt.ini chans 1 %mircCrypt.Chans }
  else { remini mirccrypt.ini chans 1 }

  ;Same as for the ActiveCrypting-list, but this time we check, whether EncryptPasses is wanted or not and if so encrypt
  ;the passes via blowfish before writing them to the ini-file:
  if ($len(%mircCrypt.ChanKeys) != 0) { 
    if ((%mircCrypt.EncryptPasses == 1) && (%mircCrypt.Password != $null) && (%mircCrypt.Password != 0)) { 
      writeini mirccrypt.ini chans 2 $dll(tetas.dll, blowfish, encrypt %mircCrypt.myPassword %mircCrypt.ChanKeys)
    }
    ;EncryptPasses is not wanted, so write the passes uncrypted to the ini-file:
    else { writeini mirccrypt.ini chans 2 %mircCrypt.ChanKeys }
  }    
  else { remini mirccrypt.ini chans 2 }

  ;Same as for the ActiveCrypting-list:
  if ($len(%mircCrypt.Nicks) != 0) { writeini mirccrypt.ini qrys 1 %mircCrypt.Nicks }
  else { remini mirccrypt.ini qrys 1 }

  ;Same as for the ChanKeys-list:
  if ($len(%mircCrypt.NickKeys) != 0) {
    if ((%mircCrypt.EncryptPasses == 1) && (%mircCrypt.Password != $null) && (%mircCrypt.Password != 0)) { 
      writeini mirccrypt.ini qrys 2 $dll(tetas.dll, blowfish, encrypt %mircCrypt.myPassword %mircCrypt.NickKeys)
    }
    else { writeini mirccrypt.ini qrys 2 %mircCrypt.NickKeys }
  }
  else { remini mirccrypt.ini qrys 2 }
}

;this alias handles the whole encryption for both, channels and queries:
alias -l mircCrypt.Encrypt {
  if (%mircCrypt.Active == 1) {
    ;we are not in a channel, atm, so we are in a query:
    if ($len($chan) == 0) {
      ;find the nick in the token for the nicks:
      %mircCrypt.temp = $findtok(%mircCrypt.Nicks,$active,32)
      ;if we found it in the token:
      if (%mircCrypt.temp != $null) {
        ;lookup the correct key in the key token:
        %mircCrypt.temp2 = $gettok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
        ;display the written text + the asteriks (*) in front of the text to show, that this line belongs to mircCrypt:
        echo -a $+(4*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$me,>,$chr(32),$1-)      
        ;if Localecho is disabled:
        if (%mircCrypt.Localecho == 0) {
          ;post the encrypted message quietly to the server:
          .msg $active $+($chr(40),C,$chr(41),$chr(42),-,$right($dll(tetas.dll, blowfish, encrypt %mircCrypt.temp2 $1-),-4)) 
        }
        ;if Localecho is enabled:
        else {
          ;post the encrypte message publicly to the server (so the user sees it on his screen):
          msg $active $+($chr(40),C,$chr(41),$chr(42),-,$right($dll(tetas.dll, blowfish, encrypt %mircCrypt.temp2 $1-),-4)) 
        }
      } 
      ;we haven't found a key matching the given nick, inform the user:
      else {
        echo -a 2[12!2] 12[mircCrypt] has no password saved to encrypt the msg you wanted to write to $active . To set on type "/mircCrypt.config" or Commands -> mircCrypt
      }
    }
    ;hey, we are in a channel :o)
    else {
      ;find the channel in the token for the chans:
      %mircCrypt.temp = $findtok(%mircCrypt.Chans,$chan,32)
      ;if we found it in the token:
      if (%mircCrypt.temp != $null) {
        ;lookup the correct key in the key token:
        %mircCrypt.temp2 = $gettok(%mircCrypt.ChanKeys,%mircCrypt.temp,32)
        ;display the written text + the asteriks (*) in front of the text to show, that this line belongs to mircCrypt:
        echo -a $+(4*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$me,>,$chr(32),$1-)
        ;if Localecho is disabled:
        if (%mircCrypt.Localecho == 0) {
          ;post the encrypted message quietly to the server:
          .msg $chan $+($chr(40),C,$chr(41),$chr(42),-,$right($dll(tetas.dll, blowfish, encrypt %mircCrypt.temp2 $1-),-4)) 
        }
        ;if Localecho is enabled:
        else {
          ;post the encrypte message publicly to the server (so the user sees it on his screen):
          msg $chan $+($chr(40),C,$chr(41),$chr(42),-,$right($dll(tetas.dll, blowfish, encrypt %mircCrypt.temp2 $1-),-4)) 
        }
      }

      ;we haven't found a key matching the given channel, inform the user:
      else {
        echo -a 2[12!2] 12[mircCrypt] has no password saved to encrypt the msg you wanted to write in $chan . To set one type "/mircCrypt.config" or Commands -> mircCrypt
      }
    }
  }
  unset %mircCrypt.temp
  unset %mircCrypt.temp2
}
else { echo -a 2[12!2] 12[mircCrypt] was deactivated. To activate it again type "/mircCrypt.config" or Commands -> mircCrypt }


alias enc {
  $mircCrypt.Encrypt($1-)
}

;################################################ EVENTS START HERE ########################################################
;this event is triggered, whenever the script is loaded, which is the case when starting mirc, /load -rs'ing the script
;or /reload -rs'ing the script:
On *:Start:{
  set %mircCrypt.RC 21
  ;First of all we need to load our settings:
  $mircCrypt.LoadSettings
  echo -s 2[12!2] 12[mircCrypt] Version 2.1 was loaded successfully !

  if (%mircCrypt.AutoUpdate == 1) {
    echo -s 2[12!2] 12[mircCrypt] checking for update ...
    sockopen updatecheck atnetz.de 80
  }

  ;Here comes the most ugly code of the script.
  if (%mircCrypt.EncryptPasses == 0) {
    ;We have to check, whether this is the first start of the script and if so ...
    if (%mircCrypt.Password == FIRSTSTART) {
      echo -s 2[12!2] 12[mircCrypt] was started the first time, please configure it now !
      ;we have to ask the user, whether he wants to save his passes encrypted on his disc, or not:
      if ($input(Do you want to protect the saved passwords with blowfish-encryption?,yqv) == $yes) {
        set %mircCrypt.EncryptPasses 1
        set %mircCrypt.Temp $?*="Enter password for de-/encryption:"
        if (%mircCrypt.Temp == $null) {
          ;if the user canceled the dialog or didn't enter a pass disable the feature:
          echo -s 2[12!2] 12[mircCrypt] You have chosen to not save the passwords encrypted !
          set %mircCrypt.EncryptPasses 0
          set %mircCrypt.Password 0
        }
        ;if the user provided a valid password, we create the md5-hash of the provided password ...
        else {
          echo -s 2[12!2] 12[mircCrypt] You've finished the first-time configuration !
          set %mircCrypt.myPassword %mircCrypt.Temp
          set %mircCrypt.Password $dll(tetas.dll, md5, %mircCrypt.Temp)
        }
      }
      ;but if the the user canceled, we ...
      else {
        echo -s 2[12!2] 12[mircCrypt] You have chosen to not save the passwords encrypted !
        ;disable this feature:
        set %mircCrypt.EncryptPasses 0
        set %mircCrypt.Password 0
      }
      ;We now write the new settings to the ini-file:
      $mircCrypt.SaveSettings

      ;This is to make sure, our script gets loaded as the first by mirc, so we have the complete power over the events.
      ;It will make mircCrypt work properly even with nnscript and/or others installed/loaded.
      ;Thanks to pnd|phreak @ #nnscript for this hint! :)
      .reload -rs1 mirccrypt.mrc
    }
  }
  ;Furthermore if this is not the first start:
  else {
    :enterpass
    ;ask the user for the password he allready gave:
    set %mircCrypt.Temp $?*="Please enter your password for de-/encryption of your mircCrypt-passwords:"
    ;if the md5-hash of the password the user entered matches the md5-hash saved:
    if (%mircCrypt.Password isin $dll(tetas.dll, md5, %mircCrypt.Temp)) {
      echo -s 2[12!2] 12[mircCrypt] Password successfully entered ... decrypting !
      ;keep the password the user entered in the variable %mircCrypt.myPassword
      set %mircCrypt.myPassword %mircCrypt.Temp
      ;and decrypt the Keys for the chans and nicks:
      set %mircCrypt.ChanKeys $right($dll(tetas.dll, blowfish, decrypt %mircCrypt.myPassword $right(%mircCrypt.ChanKeys,-4)),-4)
      set %mircCrypt.NickKeys $right($dll(tetas.dll, blowfish, decrypt %mircCrypt.myPassword $right(%mircCrypt.NickKeys,-4)),-4)
    }
    ;the md5-hash of the pass the user entered doesn't match the saved m5d-hash: 
    else {
      echo -s 2[12!2] 12[mircCrypt] You have entered a wrong password, cannot decrypt the channel- and query-keys !
      if ($input(Seems like you inserted a wrong password. TRY AGAIN?,yqv) == $yes) {
        ;the user has choosen to enter the password again:
        goto enterpass 
      }
      ;the user has canceled the entering of the pass:
      else {
        ;inform the user that mircCrypt cannot decrypt the keys without the correct pass:
        if ($input(You have not entered the valid password. If you don't have set any everything is fine. $&
          Otherwise mircCrypt won't be able to encode/decode your chats until you entered the correct password. $&
          $crlf $crlf Are you sure to cancel?,yqvi) == $no) {
          ;user has chosen to try again:
          goto enterpass
        }
      }
    }
  }   
}

;this event is triggered, if the mircCrypt dialog gets show, so we should load the current settings here:
On *:DIALOG:mircCrypt:init:*:{
  ;Give the controls on the dialog the state for: %mircCrypt.ActiveCrypting (list),
  ;%mircCrypt.Chans (list) and %mircCrypt.Nicks (list, too):
  didtok mircCrypt 1 32 %mircCrypt.ActiveCrypting
  didtok mircCrypt 2 32 %mircCrypt.Chans
  didtok mircCrypt 3 32 %mircCrypt.Nicks

  ;if Active is enabled, check the checkbox, else uncheck it:
  if (%mircCrypt.Active == 1) { did -c mircCrypt 19 } 
  else { did -u mircCrypt 19 }

  ;if AutoUpdate is enabled, check the checkbox, else uncheck it:
  if (%mircCrypt.AutoUpdate == 1) { did -c mircCrypt 27 } 
  else { did -u mircCrypt 27 }

  ;if Localecho is enabled, check the checkbox, else uncheck it:  
  if (%mircCrypt.Localecho == 1) { did -c mircCrypt 28 } 
  else { did -u mircCrypt 28 }

  if (%mircCrypt.EncryptPasses == 1) { 
    did -c mircCrypt 29
    did -n mircCrypt 21
    if ((%mircCrypt.Password == $null) || (%mircCrypt.Password == 0)) {
      ;disable the textbox for the key and uncheck the checkbox for EncryptPasses:
      did -u mircCrypt 29
      did -m mircCrypt 21
    }
    ;If it is valid:
    else {
      ;clear the actual content of the textbox and put in the md5'ed Key for encryption:
      did -r mircCrypt 21
      did -a mircCrypt 21 %mircCrypt.Password
    }
  }
  ;If EncryptPasses is disabled, uncheck the checkbox and disable the textbox for the key:
  else {
    did -u mircCrypt 29
    did -m mircCrypt 21
    did -r mircCrypt 21
  }
}

;this event is triggered, if the mircCrypt dialog gets closed, so we should save the current settings here:
On *:DIALOG:mircCrypt:close:*:{
  set %mircCrypt.Active $did(mircCrypt,19).state
  set %mircCrypt.AutoUpdate $did(mircCrypt,27).state
  set %mircCrypt.Localecho $did(mircCrypt,28).state
  set %mircCrypt.EncryptPasses $did(mircCrypt,29).state

  ;if EncryptPasses is checked and the given password in the textbox is not clear
  if ((%mircCrypt.EncryptPasses == 1) && ($did(mircCrypt,21).text != $null) && ($did(mircCrypt,21).text != 0)) {
    ;Get the value of the textbox and put it into %mircCrypt.Password:
    set %mircCrypt.Password $did(mircCrypt,21).text
    ;if the password doesn't start with +OK, we have the don't md5'ed password given:
    if ($left(%mircCrypt.Password,3) != +OK) {
      set %mircCrypt.myPassword %mircCrypt.Password
      set %mircCrypt.Password $dll(tetas.dll, md5, %mircCrypt.Password)
    }
  }
  ;Either EncryptPasses is not check or the passwort provided is invalid, so we disable this feature:
  else {
    set %mircCrypt.Password 0
    set %mircCrypt.EncryptPasses 0
  }

  ;Clear the lists for ActiveCrypting, the chans and the nicks, for the case of reloading settings.
  ;If we wouldn't do that, the list would fill up with dupes for every reload:
  did -r mircCrypt 1 | did -r mircCrypt 2 | did -r mircCrypt 3
  $mircCrypt.SaveSettings
}

;this event gets triggered whenever the user does a single click on the dialog:
On *:DIALOG:mircCrypt:sclick:*:{

  ;if the user clicked "Add" under the ActiveCrypting-list:
  if ($did == 4) {
    ;ask the user for a channel/nick:
    set %mircCrypt.temp $?="Enter Channel/Nick"
    ;add the input to the list:
    did -a mircCrypt 1 %mircCrypt.temp
    ;add the input to the token ActiveCryting:
    %mircCrypt.ActiveCrypting = $addtok(%mircCrypt.ActiveCrypting,%mircCrypt.temp,32)
  }

  ;if the user clicked "Del" under the ActiveCrypting-list:
  if ($did == 5) {
    ;if there is only one item of the token ActiveCrypting is left:
    if ($numtok(%mircCrypt.ActiveCrypting,32) == 1) {
      ;clear the list in the dialog:
      did -r mircCrypt 1
      ;remove the token:
      unset %mircCrypt.ActiveCrypting
    }
    ;there is more than one item left:
    else {
      ;get the number of the selected item:
      set %mircCrypt.NumSelected $didwm(mircCrypt,1,$did(mircCrypt,1).seltext)
      ;remove it from the list:
      did -d mircCrypt 1 %mircCrypt.NumSelected
      ;remove the item from the token:
      %mircCrypt.ActiveCrypting = $deltok(%mircCrypt.ActiveCrypting,%mircCrypt.NumSelected,32) 
    }
  }
  ;if the user clicked "Edit" under the ActiveCrypting-list:
  if ($did == 6) {
    ;get the number of the selected item:
    set %mircCrypt.NumSelected $didwm(mircCrypt,1,$did(mircCrypt,1).seltext)
    ;ask the user for the new value:
    set %mircCrypt.temp $?="Enter Channel/Nick"
    ;replace the selected value with the new value in the dialogs' list:
    did -o mircCrypt 1 %mircCrypt.NumSelected %mircCrypt.temp
    ;replace the item in the token:
    %mircCrypt.ActiveCrypting = $puttok(%mircCrypt.ActiveCrypting,%mircCrypt.temp,%mircCrypt.NumSelected,32)
  }

  ;if the user clicked "Clear List" under the ActiveCrypting-list:
  if ($did == 7) {
    ;clear the whole list in the dialog:
    did -r mircCrypt 1
    ;remove the token:
    unset %mircCrypt.ActiveCrypting
  }

  ;if the user clicked "Add" under the Channel-list:
  if ($did == 8) {
    ;ask the user for the new channel:
    set %mircCrypt.temp $?="Enter Channel"
    ;add the new channel to the list:
    did -a mircCrypt 2 %mircCrypt.temp
    ;add the new channel to the token:
    %mircCrypt.Chans = $addtok(%mircCrypt.Chans,%mircCrypt.temp,32)
    ;ask the user for the key of the new channel:
    set %mircCrypt.temp $?*="Enter Key"
    ;if the given password is allready in the token, warn the user to take another key:
    if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) {
      :again 
      set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
      if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) { goto again }
    }
    ;add the key to the token:
    %mircCrypt.ChanKeys = $addtok(%mircCrypt.ChanKeys,%mircCrypt.temp,32)
  }

  ;if the user clicked "Del" under the Channel-list:
  if ($did == 9) {
    ;if there is only one channel remaining on the list:
    if ($numtok(%mircCrypt.Chans,32) == 1) {
      ;clear the dialogs' list:
      did -r mircCrypt 2
      ;remove the tokens:
      unset %mircCrypt.Chans
      unset %mircCrypt.ChanKeys
    }
    ;if there is more than one channel left:
    else {
      ;get the number of the selected channel:
      set %mircCrypt.NumSelected $didwm(mircCrypt,2,$did(mircCrypt,2).seltext)
      ;remove the selected channel from the list:
      did -d mircCrypt 2 %mircCrypt.NumSelected
      ;remove the selected channel from the token:
      %mircCrypt.Chans = $deltok(%mircCrypt.Chans,%mircCrypt.NumSelected,32)
      ;remove the key of the selected channel from the ChanKeys token:
      %mircCrypt.ChanKeys = $deltok(%mircCrypt.ChanKeys,%mircCrypt.NumSelected,32)
    }
  }

  ;if the user clicked "Edit" under the Channel-list:
  if ($did == 10) {
    ;get the number of the selected item:
    set %mircCrypt.NumSelected $didwm(mircCrypt,2,$did(mircCrypt,2).seltext)
    ;ask the user if he would like to change the channel:
    if ($input(Do you want to change the channel?,yqv) == $yes) {
      ;ask the user for the new channel:
      set %mircCrypt.temp $?="Enter Channel"
      ;replace the selected channel with the new channel:
      did -o mircCrypt 2 %mircCrypt.NumSelected %mircCrypt.temp
      ;replace the item of the old channel with the item of the new channel in the channel token:
      %mircCrypt.Chans = $puttok(%mircCrypt.Chans,%mircCrypt.temp,%mircCrypt.NumSelected,32)
    }
    ;ask the user if he would like to change the key:
    if ($input(Do you want to change the key?,yqv) == $yes) {
      ;ask the user for the new key:
      set %mircCrypt.temp $?*="Enter Key"
      ;if the new key is allready an item of the token, warn the user to chose another key:
      if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) {
        :again 
        set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
        if ($istok(%mircCrypt.ChanKeys,%mircCrypt.temp,32) == $true) { goto again }
      }
      ;replace the old key with the new one:
      %mircCrypt.ChanKeys = $puttok(%mircCrypt.ChanKeys,%mircCrypt.temp,%mircCrypt.NumSelected,32)
    }
  }

  ;if the user clicked "Clear List" under the Channel-list:
  if ($did == 11) {
    ;clear the whole list in the dialog:
    did -r mircCrypt 2
    ;remove the token for the channel and ChanKeys:
    unset %mircCrypt.Chans | unset %mircCrypt.ChanKeys
  }

  ;if the user clicked "Add" under the Nick-list:
  if ($did == 12) {
    ;ask the user for the new nick:
    set %mircCrypt.temp $?="Enter Nick"
    ;add the new nick to the list: 
    did -a mircCrypt 3 %mircCrypt.temp
    ;add the new nick to the token Nick:
    %mircCrypt.Nicks = $addtok(%mircCrypt.Nicks,%mircCrypt.temp,32)
    ;ask the user for the new key:
    set %mircCrypt.temp $?*="Enter Key"
    ;if the new key is allready an item of the token, warn the user to chose another key:
    if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) {
      :again 
      set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
      if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) { goto again }
    }
    ;add the new Key to the token of the NickKeys:
    %mircCrypt.NickKeys = $addtok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
  }

  ;if the user clicked "Del" under the Nick-list:
  if ($did == 13) {
    ;if there is only one item remaining:
    if ($numtok(%mircCrypt.Nicks,32) == 1) {
      ;clear the whole dialogs' list:
      did -r mircCrypt 3
      ;remove the tokens for the Nicks and the NickKeys:
      unset %mircCrypt.Nicks
      unset %mircCrypt.NickKeys
    }
    ;if there is more than one item remaining:
    else {
      ;get the number of the selected item:
      set %mircCrypt.NumSelected $didwm(mircCrypt,3,$did(mircCrypt,3).seltext)
      ;remove the selected item from the dialogs' list:
      did -d mircCrypt 3 %mircCrypt.NumSelected
      ;remove the selected item from the nick token:
      %mircCrypt.Nicks = $deltok(%mircCrypt.Nicks,%mircCrypt.NumSelected,32)
      ;remove the Key for the selected item from the NickKeys token:
      %mircCrypt.NickKeys = $deltok(%mircCrypt.NickKeys,%mircCrypt.NumSelected,32)
    }
  }

  ;if the user clicked "Edit" under the Nick-list:
  if ($did == 14) {
    ;get the number of the selected Nick: 
    set %mircCrypt.NumSelected $didwm(mircCrypt,3,$did(mircCrypt,3).seltext)
    ;ask the user if he wants to change the Nick:
    if ($input(Do you want to change the Nick?,yqv) == $yes) {
      ;ask the user for the new Nick:
      set %mircCrypt.temp $?="Enter Nick"
      ;replace the selected item with the new nick:
      did -o mircCrypt 3 %mircCrypt.NumSelected %mircCrypt.temp
      ;replace the item of the selected item with the new nick in the nick-token:
      %mircCrypt.Nicks = $puttok(%mircCrypt.Nicks,%mircCrypt.temp,%mircCrypt.NumSelected,32)
    }
    ;ask the user if he wants to change the key:
    if ($input(Do you want to change the key?,yqv) == $yes) {
      ;ask the user for the new key:
      set %mircCrypt.temp $?*="Enter Key"
      ;if the new key is allready an item of the token, warn the user to chose another key:
      if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) {
        :again 
        set %mircCrypt.temp $?*="You allready have this key in your database! Please choose a unique key per chan/nick! Enter another Key:"
        if ($istok(%mircCrypt.NickKeys,%mircCrypt.temp,32) == $true) { goto again }
      } 
      %mircCrypt.NickKeys = $puttok(%mircCrypt.NickKeys,%mircCrypt.temp,%mircCrypt.NumSelected,32)
    }
  }

  ;if the user clicked "Clear List" under the Nick-list:
  if ($did == 15) {
    ;clear the whole dialogs' list:
    did -r mircCrypt 3
    ;remove the tokens for the Nicks and the NickKeys:
    unset %mircCrypt.Nicks | unset %mircCrypt.NickKeys
  }

  ;if the user clicked the checkbox for ActiveCrypting:
  if ($did == 29) {
    ;if the state of the checkbox is checked after the click:
    if ($did(mircCrypt,29).state == 1) {
      ;we should allow the user to enter a key in the nearby textbox, so enable it:
      did -n mircCrypt 21
    }
    ;if the state of the checkbox is unchecked after the click:
    else {
      ;we should lock the textbox for the key, so no input is possible:
      did -m mircCrypt 21
    }
  }

  if ($did == 32) {
    if ($exists(mirccrypt.txt)) {
      loadbuf -o mircCrypt 33 mirccrypt.txt
    }
    else {
      did -a mircCrypt 33 mircCrypt.txt could not be found in you mirc-directory. Maybe you deleted it :-(
    }
  }
}

;this event gets triggered, whenever an input should get submitted to the server in a channel:
on 1:input:#:{
  ;if the input is not a mirc-Command:
  if (($left($1,1) != /) && (!$ctrlenter)) {
    ;if the chan is on the ActiveCrypting list and mircCrypt is activated:
    if (($istok(%mircCrypt.ActiveCrypting,$chan,32) == $true) && (%mircCrypt.Active == 1)) {
      ;send the input encrypted:
      $mircCrypt.Encrypt($1-)
      ;halt the default event (surpress the submission of the unencrytped text):
      haltdef
    }
  }
}

;this event gets triggered, whenever an input should get submitted to the server in a query:
on 1:input:?:{
  ;if the input is not a mirc-Command:
  if (($left($1,1) != /) && (!$ctrlenter)) {
    ;if the nick is on the ActiveCrypting list and mircCrypt is activated:
    if (($istok(%mircCrypt.ActiveCrypting,$active,32) == $true) && (%mircCrypt.Active == 1)) {
      ;send the input encrypted:
      $mircCrypt.Encrypt($1-)
      ;halt the default event (surpress the submission of the unencrytped text):
      haltdef
    }
  }
}

;this event gets triggered, whenever a new line of text arrives from the server for a channel:
on ^*:text:*:#:{
  if (%mircCrypt.Active == 1) {
    ;if the new line starts with (C)*- (this is our symbol to sign an encrypted text!!!):
    if ($left($1,5) == $+($chr(40),C,$chr(41),$chr(42),-)) {
      ;find the channel in the token for the channels:
      %mircCrypt.temp = $findtok(%mircCrypt.Chans,$chan,1,32)
      ;if we found it in the token:
      if (%mircCrypt.temp != $null) {
        ;load the key for the channel:
        %mircCrypt.temp2 = $gettok(%mircCrypt.ChanKeys,%mircCrypt.temp,32)
        ;decrypt the message (BUT first cut off the (C)*- !!!):
        set %mircCrypt.Decrypted $dll(tetas.dll, blowfish, decrypt %mircCrypt.temp2 $right($1-,-5))
        ;if the output of tetas.dll starts with +OK, we know, the message has been decrypted successfully:
        if ($left(%mircCrypt.Decrypted,3) == +OK) {
          ;we cut off the +OK:
          set %mircCrypt.Decrypted $right(%mircCrypt.Decrypted,-4)
          ;if the Localecho for the crypted text is disabled:
          if (%mircCrypt.Localecho == 0) {
            haltdef | echo -m $chan $+(12*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$nick,>,$chr(32),%mircCrypt.Decrypted)
          }
          ;the users wants to see the encrypted messages:
          else {
            echo -m $chan $+(12*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$nick,>,$chr(32),%mircCrypt.Decrypted)
          }
        }
        ;tetas.dll told us, that something went wrong. Inform the user:
        else {
          echo $chan 2[12!2] 12[mircCrypt] was unable to decrypt the text in $chan . An unknown error occured !
        }
      }
      ;ouch, we don't have a key set for this channel, we have to inform the user:
      else {
        echo $chan 2[12!2] 12[mircCrypt] has no password saved to decrypt the text in $chan . To set on type "/mircCrypt.config" or Commands -> mircCrypt 
      }
    }
    ;unset our temporary variables:
    unset %mircCrypt.temp2
    unset %mircCrypt.Decrypted
  }
}
else { echo -a 2[12!2] 12[mircCrypt] was deactivated. To activate it again type "/mircCrypt.config" or Commands -> mircCrypt }

;this event gets triggered, whenever a new line of text arrives from the server for a query:
on ^*:text:*:?:{
  if (%mircCrypt.Active == 1) {
    if ($nick == -psyBNC) {
      if ($pos($1-,$+($chr(40),C,$chr(41),$chr(42),-),1) != $null) {
        ;get the nick of the person who stored a crypted msg for ya on the bnc
        set %mircCrypt.tempNick $mid($1-,$calc($pos($1-,$eval($chr(58) $+ $chr(40)),1)+2),$calc($pos($1-,$chr(33),1)-$calc($pos($1-,$eval($chr(58) $+ $chr(40)),1)+2)))
        %mircCrypt.temp = $findtok(%mircCrypt.Nicks,%mircCrypt.tempNick,1,32)
        ;if we found it in the token:
        if (%mircCrypt.temp != $null) {
          ;load the key for the nick:
          %mircCrypt.temp2 = $gettok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
          set %mircCrypt.Decrypted $dll(tetas.dll, blowfish, decrypt %mircCrypt.temp2 $mid($1-,$calc($pos($1-,$+($chr(40),C,$chr(41),$chr(42),-),1)+5),$len($1-)))
          ;if the output of tetas.dll starts with +OK, we know, the message has been decrypted successfully:
          if ($left(%mircCrypt.Decrypted,3) == +OK) {
            ;we cut off the +OK:
            set %mircCrypt.Decrypted $right(%mircCrypt.Decrypted,-4)
            query -psyBNC
            ;if the Localecho for the crypted text is disabled:
            if (%mircCrypt.Localecho == 0) {
              ;we should halt the default event, coz the user doesn't want to see the encrypted text
              ;and finally give out the decrypted message:
              haltdef | echo -m -psyBNC $+(12*,,$color(own text),$mid($1-,1,$calc($pos($1-,$+($chr(58),$chr(40)),1)-2)),$chr(32),$chr(58),$chr(40),%mircCrypt.tempNick,$mid($1-,$pos($1-,$chr(33),1),$calc($pos($1-,$chr(41),1)-$pos($1-,$chr(33),1)+1)),$chr(32),%mircCrypt.Decrypted)
            }
            ;the users wants to see the encrypted messages:
            else {
              echo -m -psyBNC $+(12*,,$color(own text),$mid($1-,1,$calc($pos($1-,$+($chr(58),$chr(40)),1)-2)),$chr(32),$chr(58),$chr(40),%mircCrypt.tempNick,$mid($1-,$pos($1-,$chr(33),1),$calc($pos($1-,$chr(41),1)-$pos($1-,$chr(33),1)+1)),$chr(32),%mircCrypt.Decrypted)
            }
            flash
          }
          ;tetas.dll told us, that something went wrong. Inform the user:
          else {
            echo -m -psyBNC 2[12!2] 12[mircCrypt] was unable to decrypt the text of %mircCrypt.tempNick . An unknown error occured !
          }
        }
        ;ouch, we don't have a key set for this channel, we have to inform the user:
        else {
          echo -m -psyBNC 2[12!2] 12[mircCrypt] has no password saved to decrypt the msg %mircCrypt.tempNick wrote. To set onee type "/mircCrypt.config" or Commands -> mircCrypt 
        }
      }
    }
    else {
    ;if the new line starts with (C)*- (this is our symbol to sign an encrypted text!!!):
    if ($left($1,5) == $+($chr(40),C,$chr(41),$chr(42),-)) {
      ;find the nick in the token for the channels:
      %mircCrypt.temp = $findtok(%mircCrypt.Nicks,$nick,1,32)
      ;if we found it in the token:
      if (%mircCrypt.temp != $null) {
        ;load the key for the nick:
        %mircCrypt.temp2 = $gettok(%mircCrypt.NickKeys,%mircCrypt.temp,32)
        ;decrypt the message (BUT first cut off the (C)*- !!!):
        set %mircCrypt.Decrypted $dll(tetas.dll, blowfish, decrypt %mircCrypt.temp2 $right($1-,-5))
        ;if the output of tetas.dll starts with +OK, we know, the message has been decrypted successfully:
        if ($left(%mircCrypt.Decrypted,3) == +OK) {
          ;we cut off the +OK:
          set %mircCrypt.Decrypted $right(%mircCrypt.Decrypted,-4)
          ;if the Localecho for the crypted text is disabled:
          if (%mircCrypt.Localecho == 0) {
            ;we should halt the default event, coz the user doesn't want to see the encrypted text
            ;and finally give out the decrypted message:
            haltdef | echo -m $nick $+(12*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$nick,>,$chr(32),%mircCrypt.Decrypted)
          }
          ;the users wants to see the encrypted messages:
          else {
            echo -m $nick $+(12*,,$color(own text),$asctime($timestampfmt),$chr(32),<,$nick,>,$chr(32),%mircCrypt.Decrypted)
          }
          flash
        }
        ;tetas.dll told us, that something went wrong. Inform the user:
        else {
          echo -m $nick 2[12!2] 12[mircCrypt] was unable to decrypt the text of $nick . An unknown error occured !
        }
      }
      ;ouch, we don't have a key set for this channel, we have to inform the user:
      else {
        echo -m $nick 2[12!2] 12[mircCrypt] has no password saved to decrypt the msg $nick wrote. To set on type "/mircCrypt.config" or Commands -> mircCrypt 
      }
    }
    ;unset our temporary variables:
    unset %mircCrypt.temp
    unset %mircCrypt.temp2
    unset %mircCrypt.Decrypted
  }
 }
}
else { echo -a 2[12!2] 12[mircCrypt] was deactivated. To activate it again type "/mircCrypt.config" or Commands -> mircCrypt }

;here are the auto-update handlers:
on *:sockopen:updatecheck:{
  sockwrite -n $sockname GET /mirccrypt/latest.php HTTP/1.1
  sockwrite -n $sockname HOST: atnetz.de
  sockwrite -n $sockname REFERER: http://mirccrypt.update.check/
  sockwrite -n $sockname USER-AGENT: $version
  sockwrite -n $sockname $crlf
}

on *:sockread:updatecheck:{
  if (!$sockerr) {
    sockread %mircCrypt.UpdateTemp
    if ($+($chr(91),mcAU,$chr(93)) isin %mircCrypt.UpdateTemp) {
      set %mircCrypt.UpdateTemp $decode($right(%mircCrypt.UpdateTemp,-6),m)
      if ($gettok(%mircCrypt.UpdateTemp,1,47) > %mircCrypt.RC) {
        echo -s 2[12!2] 12[mircCrypt] an update was found ! The newest version is $+($left($gettok(%mircCrypt.UpdateTemp,1,47),1),$chr(46),$right($gettok(%mircCrypt.UpdateTemp,1,47),-1))
        echo -s 2[12!2] 12[mircCrypt] You can download it here: $+(http://mirccrypt.atnetz.de/,$gettok(%mircCrypt.UpdateTemp,2,47))
        sockclose $sockname
      }
      else {
        echo -s 2[12!2] 12[mircCrypt] No updates available this time.
      }
    }
  }
  else {
    echo -s 2[12!2] 12[mircCrypt] Error while checking for update ... try again later ! | halt
  }
}
